# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class GetVpcEndpointResult(object):
    """
    A collection of values returned by getVpcEndpoint.
    """
    def __init__(__self__, cidr_blocks=None, dns_entries=None, id=None, network_interface_ids=None, policy=None, prefix_list_id=None, private_dns_enabled=None, route_table_ids=None, security_group_ids=None, service_name=None, state=None, subnet_ids=None, vpc_endpoint_type=None, vpc_id=None):
        if not cidr_blocks:
            raise TypeError('Missing required argument cidr_blocks')
        elif not isinstance(cidr_blocks, list):
            raise TypeError('Expected argument cidr_blocks to be a list')
        __self__.cidr_blocks = cidr_blocks
        """
        The list of CIDR blocks for the exposed AWS service. Applicable for endpoints of type `Gateway`.
        """
        if not dns_entries:
            raise TypeError('Missing required argument dns_entries')
        elif not isinstance(dns_entries, list):
            raise TypeError('Expected argument dns_entries to be a list')
        __self__.dns_entries = dns_entries
        """
        The DNS entries for the VPC Endpoint. Applicable for endpoints of type `Interface`. DNS blocks are documented below.
        """
        if not id:
            raise TypeError('Missing required argument id')
        elif not isinstance(id, basestring):
            raise TypeError('Expected argument id to be a basestring')
        __self__.id = id
        if not network_interface_ids:
            raise TypeError('Missing required argument network_interface_ids')
        elif not isinstance(network_interface_ids, list):
            raise TypeError('Expected argument network_interface_ids to be a list')
        __self__.network_interface_ids = network_interface_ids
        """
        One or more network interfaces for the VPC Endpoint. Applicable for endpoints of type `Interface`.
        """
        if not policy:
            raise TypeError('Missing required argument policy')
        elif not isinstance(policy, basestring):
            raise TypeError('Expected argument policy to be a basestring')
        __self__.policy = policy
        """
        The policy document associated with the VPC Endpoint. Applicable for endpoints of type `Gateway`.
        """
        if not prefix_list_id:
            raise TypeError('Missing required argument prefix_list_id')
        elif not isinstance(prefix_list_id, basestring):
            raise TypeError('Expected argument prefix_list_id to be a basestring')
        __self__.prefix_list_id = prefix_list_id
        """
        The prefix list ID of the exposed AWS service. Applicable for endpoints of type `Gateway`.
        """
        if not private_dns_enabled:
            raise TypeError('Missing required argument private_dns_enabled')
        elif not isinstance(private_dns_enabled, bool):
            raise TypeError('Expected argument private_dns_enabled to be a bool')
        __self__.private_dns_enabled = private_dns_enabled
        """
        Whether or not the VPC is associated with a private hosted zone - `true` or `false`. Applicable for endpoints of type `Interface`.
        """
        if not route_table_ids:
            raise TypeError('Missing required argument route_table_ids')
        elif not isinstance(route_table_ids, list):
            raise TypeError('Expected argument route_table_ids to be a list')
        __self__.route_table_ids = route_table_ids
        """
        One or more route tables associated with the VPC Endpoint. Applicable for endpoints of type `Gateway`.
        """
        if not security_group_ids:
            raise TypeError('Missing required argument security_group_ids')
        elif not isinstance(security_group_ids, list):
            raise TypeError('Expected argument security_group_ids to be a list')
        __self__.security_group_ids = security_group_ids
        """
        One or more security groups associated with the network interfaces. Applicable for endpoints of type `Interface`.
        """
        if not service_name:
            raise TypeError('Missing required argument service_name')
        elif not isinstance(service_name, basestring):
            raise TypeError('Expected argument service_name to be a basestring')
        __self__.service_name = service_name
        if not state:
            raise TypeError('Missing required argument state')
        elif not isinstance(state, basestring):
            raise TypeError('Expected argument state to be a basestring')
        __self__.state = state
        if not subnet_ids:
            raise TypeError('Missing required argument subnet_ids')
        elif not isinstance(subnet_ids, list):
            raise TypeError('Expected argument subnet_ids to be a list')
        __self__.subnet_ids = subnet_ids
        """
        One or more subnets in which the VPC Endpoint is located. Applicable for endpoints of type `Interface`.
        """
        if not vpc_endpoint_type:
            raise TypeError('Missing required argument vpc_endpoint_type')
        elif not isinstance(vpc_endpoint_type, basestring):
            raise TypeError('Expected argument vpc_endpoint_type to be a basestring')
        __self__.vpc_endpoint_type = vpc_endpoint_type
        """
        The VPC Endpoint type, `Gateway` or `Interface`.
        """
        if not vpc_id:
            raise TypeError('Missing required argument vpc_id')
        elif not isinstance(vpc_id, basestring):
            raise TypeError('Expected argument vpc_id to be a basestring')
        __self__.vpc_id = vpc_id

def get_vpc_endpoint(id=None, service_name=None, state=None, vpc_id=None):
    """
    The VPC Endpoint data source provides details about
    a specific VPC endpoint.
    """
    __args__ = dict()

    __args__['id'] = id
    __args__['serviceName'] = service_name
    __args__['state'] = state
    __args__['vpcId'] = vpc_id
    __ret__ = pulumi.runtime.invoke('aws:ec2/getVpcEndpoint:getVpcEndpoint', __args__)

    return GetVpcEndpointResult(
        cidr_blocks=__ret__['cidrBlocks'],
        dns_entries=__ret__['dnsEntries'],
        id=__ret__['id'],
        network_interface_ids=__ret__['networkInterfaceIds'],
        policy=__ret__['policy'],
        prefix_list_id=__ret__['prefixListId'],
        private_dns_enabled=__ret__['privateDnsEnabled'],
        route_table_ids=__ret__['routeTableIds'],
        security_group_ids=__ret__['securityGroupIds'],
        service_name=__ret__['serviceName'],
        state=__ret__['state'],
        subnet_ids=__ret__['subnetIds'],
        vpc_endpoint_type=__ret__['vpcEndpointType'],
        vpc_id=__ret__['vpcId'])
