# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class GetStreamResult(object):
    """
    A collection of values returned by getStream.
    """
    def __init__(__self__, arn=None, closed_shards=None, creation_timestamp=None, open_shards=None, retention_period=None, shard_level_metrics=None, status=None, tags=None):
        if not arn:
            raise TypeError('Missing required argument arn')
        elif not isinstance(arn, basestring):
            raise TypeError('Expected argument arn to be a basestring')
        __self__.arn = arn
        """
        The Amazon Resource Name (ARN) of the Kinesis Stream (same as id).
        """
        if not closed_shards:
            raise TypeError('Missing required argument closed_shards')
        elif not isinstance(closed_shards, list):
            raise TypeError('Expected argument closed_shards to be a list')
        __self__.closed_shards = closed_shards
        """
        The list of shard ids in the CLOSED state. See [Shard State][2] for more.
        """
        if not creation_timestamp:
            raise TypeError('Missing required argument creation_timestamp')
        elif not isinstance(creation_timestamp, int):
            raise TypeError('Expected argument creation_timestamp to be a int')
        __self__.creation_timestamp = creation_timestamp
        """
        The approximate UNIX timestamp that the stream was created.
        """
        if not open_shards:
            raise TypeError('Missing required argument open_shards')
        elif not isinstance(open_shards, list):
            raise TypeError('Expected argument open_shards to be a list')
        __self__.open_shards = open_shards
        """
        The list of shard ids in the OPEN state. See [Shard State][2] for more.
        """
        if not retention_period:
            raise TypeError('Missing required argument retention_period')
        elif not isinstance(retention_period, int):
            raise TypeError('Expected argument retention_period to be a int')
        __self__.retention_period = retention_period
        """
        Length of time (in hours) data records are accessible after they are added to the stream.
        """
        if not shard_level_metrics:
            raise TypeError('Missing required argument shard_level_metrics')
        elif not isinstance(shard_level_metrics, list):
            raise TypeError('Expected argument shard_level_metrics to be a list')
        __self__.shard_level_metrics = shard_level_metrics
        """
        A list of shard-level CloudWatch metrics which are enabled for the stream. See [Monitoring with CloudWatch][3] for more.
        """
        if not status:
            raise TypeError('Missing required argument status')
        elif not isinstance(status, basestring):
            raise TypeError('Expected argument status to be a basestring')
        __self__.status = status
        """
        The current status of the stream. The stream status is one of CREATING, DELETING, ACTIVE, or UPDATING.
        """
        if not tags:
            raise TypeError('Missing required argument tags')
        elif not isinstance(tags, dict):
            raise TypeError('Expected argument tags to be a dict')
        __self__.tags = tags
        """
        A mapping of tags to assigned to the stream.
        """

def get_stream(name=None):
    """
    Use this data source to get information about a Kinesis Stream for use in other
    resources.
    
    For more details, see the [Amazon Kinesis Documentation][1].
    """
    __args__ = dict()

    __args__['name'] = name
    __ret__ = pulumi.runtime.invoke('aws:kinesis/getStream:getStream', __args__)

    return GetStreamResult(
        arn=__ret__['arn'],
        closed_shards=__ret__['closedShards'],
        creation_timestamp=__ret__['creationTimestamp'],
        open_shards=__ret__['openShards'],
        retention_period=__ret__['retentionPeriod'],
        shard_level_metrics=__ret__['shardLevelMetrics'],
        status=__ret__['status'],
        tags=__ret__['tags'])
