# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class GetBucketObjectResult(object):
    """
    A collection of values returned by getBucketObject.
    """
    def __init__(__self__, body=None, cache_control=None, content_disposition=None, content_encoding=None, content_language=None, content_length=None, content_type=None, etag=None, expiration=None, expires=None, last_modified=None, metadata=None, server_side_encryption=None, sse_kms_key_id=None, storage_class=None, tags=None, version_id=None, website_redirect_location=None):
        if not body:
            raise TypeError('Missing required argument body')
        elif not isinstance(body, basestring):
            raise TypeError('Expected argument body to be a basestring')
        __self__.body = body
        """
        Object data (see **limitations above** to understand cases in which this field is actually available)
        """
        if not cache_control:
            raise TypeError('Missing required argument cache_control')
        elif not isinstance(cache_control, basestring):
            raise TypeError('Expected argument cache_control to be a basestring')
        __self__.cache_control = cache_control
        """
        Specifies caching behavior along the request/reply chain.
        """
        if not content_disposition:
            raise TypeError('Missing required argument content_disposition')
        elif not isinstance(content_disposition, basestring):
            raise TypeError('Expected argument content_disposition to be a basestring')
        __self__.content_disposition = content_disposition
        """
        Specifies presentational information for the object.
        """
        if not content_encoding:
            raise TypeError('Missing required argument content_encoding')
        elif not isinstance(content_encoding, basestring):
            raise TypeError('Expected argument content_encoding to be a basestring')
        __self__.content_encoding = content_encoding
        """
        Specifies what content encodings have been applied to the object and thus what decoding mechanisms must be applied to obtain the media-type referenced by the Content-Type header field.
        """
        if not content_language:
            raise TypeError('Missing required argument content_language')
        elif not isinstance(content_language, basestring):
            raise TypeError('Expected argument content_language to be a basestring')
        __self__.content_language = content_language
        """
        The language the content is in.
        """
        if not content_length:
            raise TypeError('Missing required argument content_length')
        elif not isinstance(content_length, int):
            raise TypeError('Expected argument content_length to be a int')
        __self__.content_length = content_length
        """
        Size of the body in bytes.
        """
        if not content_type:
            raise TypeError('Missing required argument content_type')
        elif not isinstance(content_type, basestring):
            raise TypeError('Expected argument content_type to be a basestring')
        __self__.content_type = content_type
        """
        A standard MIME type describing the format of the object data.
        """
        if not etag:
            raise TypeError('Missing required argument etag')
        elif not isinstance(etag, basestring):
            raise TypeError('Expected argument etag to be a basestring')
        __self__.etag = etag
        """
        [ETag](https://en.wikipedia.org/wiki/HTTP_ETag) generated for the object (an MD5 sum of the object content in case it's not encrypted)
        """
        if not expiration:
            raise TypeError('Missing required argument expiration')
        elif not isinstance(expiration, basestring):
            raise TypeError('Expected argument expiration to be a basestring')
        __self__.expiration = expiration
        """
        If the object expiration is configured (see [object lifecycle management](http://docs.aws.amazon.com/AmazonS3/latest/dev/object-lifecycle-mgmt.html)), the field includes this header. It includes the expiry-date and rule-id key value pairs providing object expiration information. The value of the rule-id is URL encoded.
        """
        if not expires:
            raise TypeError('Missing required argument expires')
        elif not isinstance(expires, basestring):
            raise TypeError('Expected argument expires to be a basestring')
        __self__.expires = expires
        """
        The date and time at which the object is no longer cacheable.
        """
        if not last_modified:
            raise TypeError('Missing required argument last_modified')
        elif not isinstance(last_modified, basestring):
            raise TypeError('Expected argument last_modified to be a basestring')
        __self__.last_modified = last_modified
        """
        Last modified date of the object in RFC1123 format (e.g. `Mon, 02 Jan 2006 15:04:05 MST`)
        """
        if not metadata:
            raise TypeError('Missing required argument metadata')
        elif not isinstance(metadata, dict):
            raise TypeError('Expected argument metadata to be a dict')
        __self__.metadata = metadata
        """
        A map of metadata stored with the object in S3
        """
        if not server_side_encryption:
            raise TypeError('Missing required argument server_side_encryption')
        elif not isinstance(server_side_encryption, basestring):
            raise TypeError('Expected argument server_side_encryption to be a basestring')
        __self__.server_side_encryption = server_side_encryption
        """
        If the object is stored using server-side encryption (KMS or Amazon S3-managed encryption key), this field includes the chosen encryption and algorithm used.
        """
        if not sse_kms_key_id:
            raise TypeError('Missing required argument sse_kms_key_id')
        elif not isinstance(sse_kms_key_id, basestring):
            raise TypeError('Expected argument sse_kms_key_id to be a basestring')
        __self__.sse_kms_key_id = sse_kms_key_id
        """
        If present, specifies the ID of the Key Management Service (KMS) master encryption key that was used for the object.
        """
        if not storage_class:
            raise TypeError('Missing required argument storage_class')
        elif not isinstance(storage_class, basestring):
            raise TypeError('Expected argument storage_class to be a basestring')
        __self__.storage_class = storage_class
        """
        [Storage class](http://docs.aws.amazon.com/AmazonS3/latest/dev/storage-class-intro.html) information of the object. Available for all objects except for `Standard` storage class objects.
        """
        if not tags:
            raise TypeError('Missing required argument tags')
        elif not isinstance(tags, dict):
            raise TypeError('Expected argument tags to be a dict')
        __self__.tags = tags
        """
        A mapping of tags assigned to the object.
        """
        if not version_id:
            raise TypeError('Missing required argument version_id')
        elif not isinstance(version_id, basestring):
            raise TypeError('Expected argument version_id to be a basestring')
        __self__.version_id = version_id
        """
        The latest version ID of the object returned.
        """
        if not website_redirect_location:
            raise TypeError('Missing required argument website_redirect_location')
        elif not isinstance(website_redirect_location, basestring):
            raise TypeError('Expected argument website_redirect_location to be a basestring')
        __self__.website_redirect_location = website_redirect_location
        """
        If the bucket is configured as a website, redirects requests for this object to another object in the same bucket or to an external URL. Amazon S3 stores the value of this header in the object metadata.
        """

def get_bucket_object(bucket=None, key=None, range=None, tags=None, version_id=None):
    """
    The S3 object data source allows access to the metadata and
    _optionally_ (see below) content of an object stored inside S3 bucket.
    
    ~> **Note:** The content of an object (`body` field) is available only for objects which have a human-readable `Content-Type` (`text/*` and `application/json`). This is to prevent printing unsafe characters and potentially downloading large amount of data which would be thrown away in favour of metadata.
    """
    __args__ = dict()

    __args__['bucket'] = bucket
    __args__['key'] = key
    __args__['range'] = range
    __args__['tags'] = tags
    __args__['versionId'] = version_id
    __ret__ = pulumi.runtime.invoke('aws:s3/getBucketObject:getBucketObject', __args__)

    return GetBucketObjectResult(
        body=__ret__['body'],
        cache_control=__ret__['cacheControl'],
        content_disposition=__ret__['contentDisposition'],
        content_encoding=__ret__['contentEncoding'],
        content_language=__ret__['contentLanguage'],
        content_length=__ret__['contentLength'],
        content_type=__ret__['contentType'],
        etag=__ret__['etag'],
        expiration=__ret__['expiration'],
        expires=__ret__['expires'],
        last_modified=__ret__['lastModified'],
        metadata=__ret__['metadata'],
        server_side_encryption=__ret__['serverSideEncryption'],
        sse_kms_key_id=__ret__['sseKmsKeyId'],
        storage_class=__ret__['storageClass'],
        tags=__ret__['tags'],
        version_id=__ret__['versionId'],
        website_redirect_location=__ret__['websiteRedirectLocation'])
